LIBRARY ieee;
   USE ieee.std_logic_1164.all;
   USE ieee.std_logic_unsigned.all;

ENTITY Power IS
	PORT (
		realAbs		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		imagAbs		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		power_out	: OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
	);
END Power;

ARCHITECTURE logic OF Power IS 
	BEGIN
	PROCESS(realAbs,imagAbs) BEGIN
		if (realAbs > imagAbs) then
			power_out <= realAbs +  ('0'&imagAbs (15 downto 1));
		else
			power_out <= imagAbs +  ('0'&realAbs (15 downto 1));
		end if;
	END PROCESS;
END logic;