`define rom_size 6'b001000

module controller(
input clk,
input rst,
input END,
output reg clock_500,
output reg [23:0] data,
output reg GO,
output wire CLOCK_2);
reg [10:0] counter;
reg [5:0] index;
reg [15:0] command;
reg [15:0] ROM[`rom_size:0];
assign CLOCK_2 = counter[0];
always begin
	GO = ((index <= `rom_size) && (END == 1))? counter[10]:1;
end


always @(negedge rst or posedge END) begin
	if (!rst) begin
		index <=0;
	end else if (index <= `rom_size) begin
		index <= index + 1;
	end
end

always @(posedge clk) begin
	counter <= counter + 1;
	clock_500 <= counter[9];
end

always @(posedge END) begin
	
	ROM[0]= 16'h0c00;	     //power down
	ROM[1]= 16'h0ec2;	     //master
	ROM[2]= 16'h083c;	     //sound select
	
	ROM[3]= 16'h1008;		 //mclk
	
	ROM[4]= 16'h0017;		 //
	ROM[5]= 16'h0217;		 //
	ROM[6]= 16'b0000010001111111;		 //
	ROM[7]= 16'b0000011001111111;	     //sound vol
	
	//ROM[4]= 16'h1e00;		 //reset	
	ROM[`rom_size]= 16'h1201;//active


/*
	//ROM[0] <= 16'h1e00; //reset
	ROM[0] <= {7'd0, 9'd24};
	ROM[1] <= 16'b0000010001111111; //left headphone out
	ROM[2] <= 16'b0000011001111111; //right headphone out 
	ROM[3] <= 16'b0000100000110100; // use DAC, mic to ADC, side tone
	ROM[4] <= 16'b0000101000000000; // digital audio path controller
	ROM[5] <= 16'b0000110000000000; //disable power off
	ROM[6] <= 16'b0000111001000001; //16bit master mode digital interface
	ROM[7] <= 16'b0001000000001000; // 8k ADC, 48K DAC, MCLK 12.288M 256fs, digital filter type 1, BOSR 0



	ROM[`rom_size] <= 16'h1201; //active
*/
	command <= ROM[index];
	data[23:0] <= {8'h34, command};
	
end
endmodule