module s2p(input clk, input data, input AUD_ADCLRCK, output reg [15:0] data_o, output reg enable,
output reg [10:0] addr);

reg [4:0] count;
reg [15:0] temp;
reg start;
reg flag;

always @(posedge clk) begin
if (AUD_ADCLRCK) begin
	if (count == 5'b10000) begin
		count <= 5'b00000;
		flag <= 1;
	end else if (!flag) begin
		count <= count + 1;
		temp <={temp[14:0], data};
	end
	
	if (count == 5'b10000) begin
		data_o <= temp;
		enable <= 1'b1;
		addr <= addr + 1;
		if (addr == 11'b11111111111) begin
			addr <= 11'b00000000000;
		end
	end else begin
		enable <= 1'b0;
	end
end
else
	flag <=0;
end
endmodule


// Quartus II Verilog Template
// 4-State Moore state machine

// A Moore machine's outputs are d						State <= S2;ependent only on the current state.
// The output is written only when the state changes.  (State
// transitions are synchronous.)

//module s2p(input clk, input data, input reset, input AUD_ADCLRCK, output reg [15:0] data_o, output reg enable,
//output reg [10:0] addr);
//
//reg [3:0] count;
//reg [15:0] temp;
//
//	// Declare state register
//	reg		[1:0]state;
//
//	// Declare states
//	parameter S0 = 0, S1 = 1, S2 = 2;
//
//	// Determine the next state
//	always @ (negedge clk or posedge reset or posedge AUD_ADCLRCK) begin
//		if (reset)
//			state <= S0;
//		else
//			case (state)
//				S0:
//					if (AUD_ADCLRCK)  begin
//						state <= S1;
//						count <= 0;
//						data_o <= 0;
//						enable <= 0;
//						temp <= 0;
//					end
//					else
//						state <= S0;
//				S1:
//					if (count != 16) begin
//						count <= count + 1;
//						temp <={temp[14:0], data};
//						addr <= addr;
//						enable <= 0;
//						data_o <= 0;
//						state <= S1;
//					end
//					else begin
//						count <= 0;
//						if (addr == 2048) begin
//							addr <= 0;
//						end else begin
//							addr = addr + 1;
//						end
//						data_o <= temp;
//						enable <= 1;
//						state <= S2;
//					end		
//				S2:
//					if (!AUD_ADCLRCK)
//						state <= S0;
//					else
//						state <= S2;
//
//			endcase
//	end
//
//endmodule




